app = angular.module 'ngFileDrop', []
app.directive 'dropZone', ->
	restrict: 'A'
	link: (scope, element, attrs) ->
		element[0].addEventListener 'dragover', (event) ->
			event.preventDefault()
			event.stopPropagation()
			angular.element(this).addClass 'dragging'
			return
		element[0].addEventListener 'dragleave', (event) ->
			event.preventDefault()
			event.stopPropagation()
			angular.element(this).removeClass 'dragging'
			return
		element[0].addEventListener 'drop', (e) ->
			console.log e
			do e.stopPropagation
			do e.preventDefault

			files = e.dataTransfer.files

			reader = new FileReader
			reader.readAsDataURL files[0]
			reader.onload = (res) ->
				scope.$apply ->
					scope.file = res.target.result

			count = files.length
			scope.$apply ->
				scope.files = []
			for file in files
				reader = new FileReader
				reader.readAsDataURL file
				reader.onload = (res) ->
					scope.$apply ->
						scope.files.push res.target.result
					count--
					if count == 0
						scope.$apply ->
							do scope.drop
					console.log files
	scope: 
		file: '=file'
		files: '=files'
		drop: '=drop'